

// Tracks whether we're in validation of cyclic objects.
var cyclicValidation = new WeakMap();
// Tracks whether we're toString() of cyclic objects.


var cyclicToString = new WeakSet();

export function inValidationCycle(type, input) {
  var tracked = cyclicValidation.get(type);
  if (!tracked) {
    return false;
  } else {
    return tracked.has(input);
  }
}

export function startValidationCycle(type, input) {
  var tracked = cyclicValidation.get(type);
  if (!tracked) {
    tracked = new WeakSet();
    cyclicValidation.set(type, tracked);
  }
  tracked.add(input);
}

export function endValidationCycle(type, input) {
  var tracked = cyclicValidation.get(type);
  if (tracked) {
    tracked.delete(input);
  }
}

export function inToStringCycle(type) {
  return cyclicToString.has(type);
}

export function startToStringCycle(type) {
  cyclicToString.add(type);
}

export function endToStringCycle(type) {
  cyclicToString.delete(type);
}