'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = makeErrorMessage;

var _Validation = require('./Validation');

var Placeholder = Symbol('Placeholder');

function makeErrorMessage(path, message) {
  var actual = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Placeholder;

  var prefixed = (0, _Validation.stringifyPath)(path) + ' ' + message;

  if (actual !== Placeholder) {
    return prefixed + ', got ' + String(actual);
  } else {
    return prefixed;
  }
}